/* aer3d.f -- translated by f2c (version 19970805).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Subroutine */ int aer3d_c(integer *nm, integer *n, integer *mbw, doublereal
        *a, doublereal *e21, integer *m, doublereal *w, doublereal *z__, 
        integer *ierr, integer *nv, doublereal *rv, doublereal *rv6)
{
    /* Initialized data */

    static doublereal sys051 = 1.1107652e-16;

    /* System generated locals */
    integer a_dim1, a_offset, z_dim1, z_offset, i__1, i__2, i__3, i__4, i__5;
    doublereal d__1;

    /* Builtin functions */
    double sqrt(doublereal), d_sign(doublereal *, doublereal *);

    /* Local variables */
    static integer maxj, maxk;
    static doublereal norm;
    static integer i__, j, k, r__;
    static doublereal u, v, order;
    static integer group, m1;
    static doublereal x0, x1;
    static integer mb, m21, ii, ij, jj, kj;
    static doublereal machep, uk, xu;
    static integer ij1, kj1, its;
    static doublereal eps2, eps3, eps4;


#define a_ref(a_1,a_2) a[(a_2)*a_dim1 + a_1]
#define z___ref(a_1,a_2) z__[(a_2)*z_dim1 + a_1]

    /* Parameter adjustments */
    --rv6;
    a_dim1 = *nm;
    a_offset = a_dim1 + 1;
    a -= a_offset;
    z_dim1 = *nm;
    z_offset = z_dim1 + 1;
    z__ -= z_offset;
    --w;
    --rv;

    /* Function Body */
    machep = sys051;
    *ierr = 0;
    if (*m == 0) {
        goto L37;
    }
    mb = *mbw;
    if (*e21 < 0.) {
        mb = (*mbw + 1) / 2;
    }
    m1 = mb - 1;
    m21 = m1 + mb;
    order = 1. - abs(*e21);
/*     ********** */
    i__1 = *m;
    for (r__ = 1; r__ <= i__1; ++r__) {
        its = 1;
        x1 = w[r__];
        if (r__ != 1) {
            goto L4;
        }
/*     ********** */
        norm = 0.;
        i__2 = mb;
        for (j = 1; j <= i__2; ++j) {
            jj = mb + 1 - j;
            kj = jj + m1;
            ij = 1;
            i__3 = *n;
            for (i__ = jj; i__ <= i__3; ++i__) {
                norm += (d__1 = a_ref(i__, j), abs(d__1));
                if (*e21 >= 0.) {
                    goto L1;
                }
                norm += (d__1 = a_ref(ij, kj), abs(d__1));
                ++ij;
L1:
                ;
            }
/* L2: */
        }
        if (*e21 < 0.) {
            norm *= .5;
        }
/*     ********** */
        if (norm == 0.) {
            norm = 1.;
        }
        eps2 = 1. - norm * 3 * abs(order);
        eps3 = machep * norm;
        uk = sqrt((doublereal) (*n));
        eps4 = uk * eps3;
L3:
        group = 0;
        goto L5;
/*     ********** */
L4:
        if ((d__1 = x1 - x0, abs(d__1)) >= eps2) {
            goto L3;
        }
        ++group;
        if (order * (x1 - x0) <= 0.) {
            x1 = x0 + order * eps3;
        }
/*     ********** */
L5:
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
/* Computing MIN */
            i__3 = 0, i__4 = i__ - m1;
            ij = i__ + min(i__3,i__4) * *n;
            kj = ij + mb * *n;
            ij1 = kj + m1 * *n;
            if (m1 == 0) {
                goto L10;
            }
            i__3 = m1;
            for (j = 1; j <= i__3; ++j) {
                if (ij > m1) {
                    goto L6;
                }
                if (ij > 0) {
                    goto L7;
                }
                rv[ij1] = 0.;
                ij1 += *n;
                goto L7;
L6:
                rv[ij] = a_ref(i__, j);
L7:
                ij += *n;
                ii = i__ + j;
                if (ii > *n) {
                    goto L9;
                }
                jj = mb - j;
                if (*e21 >= 0.) {
                    goto L8;
                }
                ii = i__;
                jj = mb + j;
L8:
                rv[kj] = a_ref(ii, jj);
                kj += *n;
L9:
                ;
            }
L10:
            rv[ij] = a_ref(i__, mb) - x1;
            rv6[i__] = eps4;
            if (order == 0.) {
                rv6[i__] = z___ref(i__, r__);
            }
/* L11: */
        }
        if (m1 == 0) {
            goto L20;
        }
/*     ********** */
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
            ii = i__ + 1;
/* Computing MIN */
            i__3 = i__ + m1 - 1;
            maxk = min(i__3,*n);
/* Computing MIN */
            i__3 = *n - i__, i__4 = m21 - 2;
            maxj = min(i__3,i__4) * *n;
            i__3 = maxk;
            for (k = i__; k <= i__3; ++k) {
                kj1 = k;
                j = kj1 + *n;
                jj = j + maxj;
                i__4 = jj;
                i__5 = *n;
                for (kj = j; i__5 < 0 ? kj >= i__4 : kj <= i__4; kj += i__5) {
                    rv[kj1] = rv[kj];
                    kj1 = kj;
/* L12: */
                }
                rv[kj1] = 0.;
/* L13: */
            }
            if (i__ == *n) {
                goto L19;
            }
            u = 0.;
/* Computing MIN */
            i__3 = i__ + m1;
            maxk = min(i__3,*n);
/* Computing MIN */
            i__3 = *n - ii, i__5 = m21 - 2;
            maxj = min(i__3,i__5) * *n;
            i__3 = maxk;
            for (j = i__; j <= i__3; ++j) {
                if ((d__1 = rv[j], abs(d__1)) < abs(u)) {
                    goto L14;
                }
                u = rv[j];
                k = j;
L14:
                ;
            }
            j = i__ + *n;
            jj = j + maxj;
            if (k == i__) {
                goto L16;
            }
            kj = k;
            i__3 = jj;
            i__5 = *n;
            for (ij = i__; i__5 < 0 ? ij >= i__3 : ij <= i__3; ij += i__5) {
                v = rv[ij];
                rv[ij] = rv[kj];
                rv[kj] = v;
                kj += *n;
/* L15: */
            }
            if (order != 0.) {
                goto L16;
            }
            v = rv6[i__];
            rv6[i__] = rv6[k];
            rv6[k] = v;
L16:
            if (u == 0.) {
                goto L19;
            }
            i__5 = maxk;
            for (k = ii; k <= i__5; ++k) {
                v = rv[k] / u;
                kj = k;
                i__3 = jj;
                i__4 = *n;
                for (ij = j; i__4 < 0 ? ij >= i__3 : ij <= i__3; ij += i__4) {
                    kj += *n;
                    rv[kj] -= v * rv[ij];
/* L17: */
                }
                if (order == 0.) {
                    rv6[k] -= v * rv6[i__];
                }
/* L18: */
            }
L19:
            ;
        }
/*     ********** */
L20:
        i__2 = *n;
        for (ii = 1; ii <= i__2; ++ii) {
            i__ = *n + 1 - ii;
            maxj = min(ii,m21);
            if (maxj == 1) {
                goto L22;
            }
            ij1 = i__;
            j = ij1 + *n;
            jj = j + (maxj - 2) * *n;
            i__5 = jj;
            i__4 = *n;
            for (ij = j; i__4 < 0 ? ij >= i__5 : ij <= i__5; ij += i__4) {
                ++ij1;
                rv6[i__] -= rv[ij] * rv6[ij1];
/* L21: */
            }
L22:
            v = rv[i__];
            if (abs(v) >= eps3) {
                goto L23;
            }
/*     ********** */
            if (order == 0.) {
                *ierr = -r__;
            }
            v = d_sign(&eps3, &v);
L23:
            rv6[i__] /= v;
/* L24: */
        }
        xu = 1.;
        if (order == 0.) {
            goto L34;
        }
/*     ********** */
        if (group == 0) {
            goto L28;
        }
        i__2 = group;
        for (jj = 1; jj <= i__2; ++jj) {
            j = r__ - group - 1 + jj;
            xu = 0.;
            i__4 = *n;
            for (i__ = 1; i__ <= i__4; ++i__) {
/* L25: */
                xu += rv6[i__] * z___ref(i__, j);
            }
            i__4 = *n;
            for (i__ = 1; i__ <= i__4; ++i__) {
/* L26: */
                rv6[i__] -= xu * z___ref(i__, j);
            }
/* L27: */
        }
L28:
        norm = 0.;
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
/* L29: */
            norm += (d__1 = rv6[i__], abs(d__1));
        }
        if (norm >= 0.) {
            goto L32;
        }
/*     ********** */
        if (its >= *n) {
            goto L31;
        }
        ++its;
        xu = eps4 / (uk + 1.);
        rv6[1] = eps4;
        i__2 = *n;
        for (i__ = 2; i__ <= i__2; ++i__) {
/* L30: */
            rv6[i__] = xu;
        }
        rv6[its] -= eps4 * uk;
        goto L20;
/*     ********** */
L31:
        *ierr = -r__;
        xu = 0.;
        goto L34;
/*     ********** */
L32:
        u = 0.;
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
/* L33: */
/* Computing 2nd power */
            d__1 = rv6[i__];
            u += d__1 * d__1;
        }
        xu = 1. / sqrt(u);
L34:
        i__2 = *n;
        for (i__ = 1; i__ <= i__2; ++i__) {
/* L35: */
            z___ref(i__, r__) = rv6[i__] * xu;
        }
        x0 = x1;
/* L36: */
    }
L37:
    return 0;
} /* aer3d_c */

#undef z___ref
#undef a_ref
